/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		Li-Iondrp[dԊ֐
 *
 *		Li-Ion[d@ɉ[dԊ֐ƒg֐܂݂܂B
 *
 * \par pLq:
 *		AVR463: BC100ł ݓdȑ[d
 *
 * \par 
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		Support email: avr@atmel.com
 *
 * $Name$
 * $Revision: 4254 $
 * $RCSfile$
 * $URL: http://revisor.norway.atmel.com/AppsAVR8/avr458_Charging_Li-Ion_Batteries_with_BC100/trunk/code/IAR/LIIONcharge.c $
 * $Date: 2008-07-25 12:32:45 +0200 (fr, 25 jul 2008) $\n
 ******************************************************************************/

#include <ioavr.h>

#include "enums.h"
#include "structs.h"

#include "battery.h"
#include "charge.h"
#include "chargefunc.h"
#include "main.h"
#include "menu.h"
#include "LIIONspecs.h"
#include "PWM.h"
#include "time.h"

#ifndef LIION
#error main.hLIION`!
#endif // LIION

//******************************************************************************
// ֐
//******************************************************************************
/*! \brief [d
 *
 * ̊֐͊eiKɕꂽg̏[d@܂݂܂B\n
 * eiKɑ΂PWMJn/~AvA~A[dҰݒ肳꓾
 * B\n
 * [d֐͕K̏ԂԂAُ킪NȂ肱͎̏[dԂłB
 *
 * \note {̋Kɏ][dɊւĂ \ref charge.h JAPANREGS`
 * B̏ꍇA[dST_MAXVOLTCURRԂgp܂B
 *
 * \note ƒiKKvƂȂAPmenu.hɂƏԂ`Amenu.c
 *  \ref menu_state[] ł܂߁AĂ̊֐caseǉĂB
 *
 * \note ̕@Li-IondrpłB
 */
unsigned char Charge(unsigned char inp)
{
	unsigned char NextState;

	switch (CurrentState) {
	case ST_PREQUAL:		/* \[d */
	// `ꂽ\[ddŏ[dAُ킪NȂΎ̏ԂƂST_CCURRENTԂ܂B
		ChargeParameters.Current = BAT_CURRENT_PREQUAL;		// [ddw
#ifdef JAPANREGS
		ChargeParameters.NextState = ST_MAXVOLTCURR;		// {dlŁAd/d[dԎw
#else
		ChargeParameters.NextState = ST_CCURRENT;			// {dlȊOŁAd[dԎw
#endif // JAPANREGS
		HaltParameters.HaltFlags = (HALT_VOLTAGE_MAX | HALT_TIME |	// ~׸ގw(dBƎԒ)
		                            HALT_FLAG_EXHAUSTION);			// (Ԓ߂͏ՓdrӖ܂B)
		HaltParameters.TemperatureMax = BAT_TEMPERATURE_MAX;		// xw
		HaltParameters.TemperatureMin = BAT_TEMPERATURE_MIN;		// xw
		HaltParameters.VoltageMax = BAT_VOLTAGE_PREQUAL;			// dw
		PWM_Start();												// PWMJn
		Time_Set(TIMER_CHG, BAT_TIME_PREQUAL, 0, 0);				// \[dvn
		NextState = ConstantCurrent();								// [d̎̏ԂdɎw
	break;
	case ST_CCURRENT:		/* d[d */
		Time_Set(TIMER_CHG,BattData.MaxTime,0,0);					// [dԌvn
		ChargeParameters.Current = BattData.MaxCurrent;				// Ήő[ddw
		ChargeParameters.NextState = ST_CVOLTAGE;					// ̏Ԃd[dɎw
		HaltParameters.VoltageMax = BAT_VOLTAGE_MAX;				// dw
		NextState = ConstantCurrent();								// [d̎̏ԂdɎw
	break;
	case ST_CVOLTAGE:		/* d[d */
		ChargeParameters.Voltage = BAT_VOLTAGE_MAX;					// Ήő[ddw
		ChargeParameters.NextState = ST_ENDCHARGE;					// ̏Ԃ[dIɎw
		HaltParameters.HaltFlags = (HALT_CURRENT_MIN | HALT_TIME);	// ~׸ގw(dBƎԒ)
		HaltParameters.CurrentMin = BattData.MinCurrent;			// dw
		NextState = ConstantVoltage();								// [d̎̏ԂdɎw
	break;
	case ST_MAXVOLTCURR:	/* őd/d[d */
		ChargeParameters.NextState = ST_ENDCHARGE;					// ̏Ԃ[dIɎw
		HaltParameters.HaltFlags = (HALT_CURRENT_MIN | HALT_TIME);	// ~׸ގw(dBƎԒ)
		HaltParameters.CurrentMin = BattData.MinCurrent;			// dw
		Time_Set(TIMER_CHG,BattData.MaxTime,0,0);					// [dԌvn
        NextState = MaxVoltageAndCurrent();							// [d̎̏Ԃd/dɎw
	break;
	case ST_ENDCHARGE:		/* [dI */
		PWM_Stop();													// PWM~
		BattData.Charged = TRUE;									// [dς׸ސݒ
		if (BattControl[(BattActive+1)%2].Enabled) {				// ̓drȂA
			NextState = ST_BATCON;									// ̏ԂdrɎw
		} else {													// ̓dr֎~ȂA
			NextState = ST_SLEEP;									// ̏Ԃx~(ذ)Ɏw
		}
	break;

	default:				// ŏI点Ă͂܂BŜ߂ɍď܂B
		NextState = ST_INIT;										// ̏ԂɎw
		break;
	}
	return(NextState);		// main()ւ̎̏ԕƋɕA
}
